"""
Package `core` contains classes to represent entities in computational biology.
These representations can be structural or
sequence-based.

Structural Representations:

- `Protein` class in `protein`: Represents structural data of a protein.
- `Chain` class in `chain`: Represents structural data of a chain.
- `Residue` class in `residue`: Represents structural data of a residue.
- `Atom` class in `atom`: Represents structural data of an atom.

Sequence Representations:

- `Sequence` class in `sequence`: Represents sequence data.
- `ProteinSequence` class in `protein_sequence`: Represents sequence data of a protein.
- `AntibodySequence` class in `antibody_sequence`: Represents sequence data of an antibody.
- `NucleotideSequence` class in `nucleotide_sequence`: Represents sequence data of a nucleotide.
"""

