"""
Package `properties` contains classes to calculate properties of proteins.

Properties are divided into various categories:

- Chemical Identity: Properties that describe the chemical composition of molecules.
- Physiochemical: Properties that describe the physical and chemical characteristics of molecules.
- Pharmacophore: Properties that relate to the recognition and binding of a molecule to its biological target.
- Structural: Properties related to the three-dimensional structure of a molecule.

Currently, the following properties are implemented:

Physiochemical Properties:

- Class `Hydrophobicity` in `hydrophobicity`: Calculates the hydrophobicity of a residue, chain or protein.
- Class `Mass` in `mass`: Calculates the mass of an atom, residue, chain or protein.

"""